% MEC2358 Controle de Sistemas Mecânicos
% Prof Helon Ayala

% Atividade - Atuador Linear com entrada harmonica

clc
clear
close all
rng(1) % permite reprodutibilidade

foldername='Freq response'; % choose the data folder

order = 1;
framelen = 11;

SAVE=0; % flag para salvar plot dados (1=salvar)
PLOT=1; % flag para plotar os dados   (1=plotar)

%% Plot dados
D=dir(foldername);    % diretório da pasta
path=pwd;                 % diretorio atual (do script)
cd([path '\' foldername])

for i=3:(size(D,1))
    filename=D(i).name;            % nome do arquivo .mat
    load(filename);                % carrega os dados
    w=str2num(filename(15:18))/100;
    T=2*pi/w;
    W(i-2)=w;                      % frequencia de excitacao
    
    if w<=4
        order = 1;
        framelen = 11;
    elseif 4<=w<7 
        order = 1;
        framelen = 9;
    elseif 7<=w<12
        order = 1;
        framelen = 7;
    else
        order = 1;
        framelen = 5;        
    end
    
    time=signals.Time;
    Ts=time(2)-time(1);            % tempo de amostragem
    input=signals.Data(:,1);
    pos=signals.Data(:,2);
    pos_fil=sgolayfilt(pos,order,framelen);
    vel=diff(pos_fil)/Ts;
    vel_fil = sgolayfilt(vel,order,framelen);
    
    % Plot Dados
    if PLOT==1
        figure
        subplot(3,1,1);
        plot(time(2:end),input(2:end),'k','linewidth',1)
        ylabel('Voltage (V)')
        title(sprintf('LA12 Frequency Response - %.2f rad/s',w))

        subplot(3,1,2);
        plot(time(2:end),pos(2:end),'r','linewidth',1)
        hold on 
        plot(time(2:end),pos_fil(2:end),'--k','linewidth',1)
        ylabel('Position (mm)')
        legend('non-filtered','filtered')
        hold off

        subplot(3,1,3);
        plot(time(2:end),vel,'b','linewidth',1)
        hold on
        plot(time(2:end),vel_fil,'--k','linewidth',1)
        xlabel('Time(s)')
        ylabel('Speed (mm/s)')
        legend('non-filtered','filtered')
        hold off
        set(gcf,'color','w');
        % salva o plot
        if SAVE==1
           saveas(gcf,filename(1:end-4),'png')
        end
    end
       
end

cd(path)